
'FOSSGIS 2019
SQL für QGIS und SpatiaLite.
Verschiedene Übungen 
'
'INFOS IM NETZ'
http://www.gaia-gis.it/gaia-sins/index.html  					-- Spatialite-Webseite
http://www.gaia-gis.it/gaia-sins/spatialite-sql-4.3.0.html 			-- Spatialite-SQL-Funktionen
http://www.sqlite.org/lang.html							-- SQLite-Sql-Syntax
http://northredoubt.com/n/2012/10/19/spatialite-and-triggers-to-update-data/	-- Trigger in SpatiaLite

http://www.gaia-gis.it/gaia-sins/windows-bin-amd64/spatialite_gui-4.3.0a-win-amd64.7z	-- Download SpatiaLite-Gui

https://www.surfaces.co.il/spatialite-speedup-your-query-with-spatial-indexing/	--Zu räumlichen Idexen
https://www.gaia-gis.it/fossil/libspatialite/wiki?name=SpatialIndex		-- Zu räumlichen Indexen
-----



'LOS GEHTS!'
--------------------------------------------
'SÄMTLICHE SHAPES AUS gemeinden IN EINE SPATIALITE-DATENBANK SCHREIBEN'
'DEN TEXT IN EINE EIGENE DATEI KOPIEREN UND ALS shp2sqlite in das Verzeichnis bin im Nutzerverzeichnis speichern'
--Mit diesem Skript wird aus den Shapefiles im NRW-Ordner eine SpatiaLite-Datenbank erzeugt
#!/bin/bash
# shp2sqlite-Shapes zu SQLITE
for shps in *.shp; do
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -nlt PROMOTE_TO_MULTI -skipfailures -append -gt unlimited -a_srs EPSG:25832 ziel.sqlite $shps
done
#csv-Dateien
for csvs in *.csv; do
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -update -append -gt unlimited-skipfailures ziel.sqlite $csvs
done
# Excel-Dateien
for xlsxs in *.xlsx; do
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -update -append -gt unlimited -skipfailures ziel.sqlite $xlsxs
done
---------------------------------------------------------------------------------------
-- Windows-Version des gleichen Skripts
# 'shp2sqlite.bat'
for %%x in (*.shp) do (
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -nlt PROMOTE_TO_MULTI -skipfailures -append -gt unlimited -a_srs EPSG:25832 ziel.sqlite %%xx
)
#csv-Dateien
for %%x in (*.csv) do (
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -update -append -gt unlimited-skipfailures ziel.sqlite %%x
)
# Excel-Dateien
for %%x in (*.xlsx) do (
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -update -append -gt unlimited -skipfailures ziel.sqlite %%x
)
------------------------------------------------------------

'Neue Layer in eine SpatiaLite-Datenbank importieren:'
--Über den Speichern als-Dialog lassen sich Layer in eine SpatiaLite-Datenbank schreiben.
-- Weitere Möglichkeit DB-Verwaltung: Erlaubt auch Umprojizieren beim Import
Datenbank > DB-Verwaltung > DB-Verwaltung
Dort: Tabelle > Layer importieren
Primärschlüssel und Codierung utf.8 wählen
Räumlichen Index anlegen
Umprojizieren wenn möglich.

'SPATIALITE_DATENBANK iIN QGISANMELDEN'
Layer > Layer hinzufügen > SpatiaLite-Layer  hinzufügen
NEU klicken und Datenbank ziel.sqlite auswählen
Geht auch im Datenbankmanager: 
Rechtsklick auf SpatiaLite im  Datenbankbaum > Neue Verbindung


'ERWEITERUNG QSPATIALITE INSTALLIEREN'
-- Nützliche Erweiterung zum Absetzen von SQL-Abfragen in SpatiaLite
-- Primrschlüssel und Geometriespalte werden automatisch angelegt
--Erweiterungen > Erweiterungen verwalten und installieren

------
'EINGEBAMÖGLICHKEITEN FÜR SQL'
-- Virtuelle Layer
Layer > Layer hinzufügen > Virtuelle Layer
Zugriff auf alle geladenen Layer, virtueller layer wird dynamisch im Projekt erzeugt
Langsam! SpatiaLite-SQL und alle Funktionen des Ausdruckseditors sind verfügbar.

---Verarbeitungs-Toolbox
QGIS-Geo-Algorithmen > Allgemeine Vektorwerkzeuge > SQL-Anweisung ausführen
Erzeugt einen neuen Layer in einem beliebigen Format.
Direktes schreiben in SpatiaLite-Tabelle schlägt fehlt

GDAL/OGR > Verschiedenes > SQL-Anweisung ausführen
basiert auf ogr2ogr

---- Datenbankmanager
Datenbank > DB-Verwaltung > DB-Verwaltung
Dort SQL-Fenster öffnen
Über die kleine SQL-Schaltfläche ist eine grafische Hilfe verfügbar

---Erweiterung QSpatiaLite
Mit grafischer Engabehife,
Ermöglcht es eine weitere Befehle Primärschlüssel anzulegen und Geometriespalte zu definieren

---spatialitegui Download auf der SpatiaLite-Webseite
Eigenes Programm, erlaubt die Eingabe ganzer SQL-Skripte.
Unabhängig von QGIS. Im Linux über Paketmanager installieren.
Für Windows:
http://www.gaia-gis.it/gaia-sins/windows-bin-amd64/spatialite_gui-4.3.0a-win-amd64.7z

-- SQLite-Studio und SQLitebrowser
Sehr gut gestaltete GUI für SQLite

https://sqlitebrowser.org/dl/

https://sqlitestudio.pl/index.rvt?act=download


Einbinden der SpatiaLite-Moduls nowendig!



'Lektion 1: LANDKREISE AUS GEMEINDEN GENERIEREN'

'Inhalt anzeigen'
-- In der DB-Verwaltung das SQL-Fenster aufrufen
-- Datenbank > SQL-Fenster (F2)
-- In der DB-Verwaltung und in QspatiaLite ist jeweils nur eine Abfrage ausführbar
-- Kein Skript, mit durch ; getrennten Abfragen.


-- Abfrage eingeben
select              -- Auswahl aus einer Tabelle
*                   -- sämtliche Spalten werden angezeigt
from gemeinden      -- die Tabelle von der gewählt wird

--Bei der Abfrage einzelne Spalten angeben und über as mit einem Alias versehen
select 
rs as regionalschluessel, --Spalte rs wird als regionalschluessel angezeigt
gen as name               --Spalte gen wird als name angezeigt
from gemeinden
-- Einwohnertabelle anzeigen
select
*
from ewz

'EINWOHNER AN DIE GEMEINDEN ANBINDEN'
-- Abfrage
select
h.GEOMETRY as GEOMETRY,
h.rs as rs,
h.gen as gen,
e.ewz as ewz
from gemeinden as h join ewz as e on (e.rs = h.rs)  
-- h.geometry enthält die Polygon-Geometrie der Gemeinden // In Datenbanken gibt es Geometriespalten.
-- gemeinden bekommt den Alias h und ewz den Alias e.
-- h.rs bedeutet die Spalte rs der tabelle h, was der Alias von gemeinden ist.
-- Mit join wird die ewz-Tabelle über ein gemeinsames Schlüsselfeld angebunden
-- on (e.rs = h.rs)  verbindet beide Tabellen über die Schlüsselspalten h.rs und e.rs
-- In beiden Tabellen gibt es den Regionalschlüssel


'NEUER LAYER MIT EWZ ERZEUGEN'
-- Mit create table wirs aus der Abfrage eine neue Rabelle
create table gemeinden_ewz as --erzeugt eine neue Tabelle gemeinden_ewz aus der vorherigen Abfrage
select
casttomultipolygon(g.GEOMETRY) as GEOMETRY,
g.rs as rs,
g.gen as gen,
e.ewz as ewz
from gemeinden as g left outer join ewz as e on (e.rs = g.rs);

--In Spatialite muss die Geometrie in die Metadaten geschrieben werden
-- Dies lässt sich mit folgendem Aufruf umsetzen

Select RecoverGeometryColumn("gemeinden_ewz",'GEOMETRY',25833,'MULTIPOLYGON');  --legt die Geometriespalte an

--Im folgenden wird noch ein räumlicher Index angelegt, der ein schnelleres Verarbeiten des neuen Layers erlaubt.

Select CreateSpatialIndex("gemeinden_ewz",'GEOMETRY');  --erzeugt einen räumlichen Index

-- Für beide Funktionen stehen GUI-Funktionen in QSpatiaLite und SpatiaLiteGui zur Verfügung
QSPatiaLite:
Option: Create Spatial Table & load in QGIS
SpatiaLiteGui: Rechte Maustaste auf Geometrie: Recover GeometryColumn
--------

'Die geometrielose Landkreistabelle mit den Landkreisnamen soll an die gemeinden gejoint werden.'
--INHALT VON GEMEINDEN UND LANDKREISEN ANZEIGEN'
select
*
from lkr
--dann
select
*
from gemeinden
------------------------------------

'KREISID UND REGIONALSCHLÜSSEL mit UNION VERGLEICHEN'
-- Beide Teile der UNION-Abfrage müssen die gleichen  Spalten haben, darum über Alias-Bildung umbennen!
-- Der Vergleich wird über where auf die kreisfreie Stadt Bonn beschränkt
-- Die Where-Klausel dient der Auswahl bestimmter Zeilen und entspricht dem, was im QGIS-Ausdruckseditor passiert.
select
'Kreise' as tabelle,		   -- Bezeichnung der Ursprungstabelle ueber text 'Kreise'
krid as id,                        -- krid wird als Spalte id ausgegeben
nam as name                        -- nam wird als Spalte Name ausgeben
from lkr                           -- gewählt von der Tabelle Landkreise  
where nam like '%Bonn%'            -- Nur Zeilen mit der Zeichenkette Bonn in der Spalte nam

union -- Beide Abfragen werden untereinandergeschrieben

select
'Gemeinden' as tabelle,		   -- Bezeichnung der Ursprungstabelle ueber text 'Gemeinden'
rs as id,                          -- rs wird als Spalte id ausgegeben
gen as name                        -- gen wird als Spalte Name ausgebe
from gemeinden                     -- gewählt von der Tabelle gemeinden 
where gen like '%Bonn%'            -- Nur Zeilen mit der Zeichenkette Bonn in der Spalte gen

order by id desc  --Absteigende Sortierung nach id

'ERGEBNIS:'
--krid aus lkr besteht aus dem 2. bis 5. Zeichen des Regionalschlüssel rs
--------------------------------------------------------------


'Mit der Funktion substr(spaltenname,StelleDesErstenZeichen,AnzahlZeichen) KREISID AUS GeMEINDE ANZEIGEN'
select
gen,
substr(rs,1,5) as krid -- aus der Spalte rs werden jeweils ab dem zweiten Zeichen vier Zeichen in eine neue Spalte krid geschrieben
from gemeinden
order by krid;
--substr gibt es auch als Funktion im Ausdruckseditor

'GRUPPIEREN NACH LANDKREISBEZUG, damit es nur eine Zeile je kreisid gibt: group by steht immer hinter from und where'
select
substr(rs,1,5) as krid
from gemeinden
group by substr(rs,1,5) -- Alle Zeilen mit dem gleichen krid werden zusammengefasst es gibt nur eine Zeile je landkreis

'WEITERE ZEILEN AUS DER GEMEINDETABELLE MITNEHMEN UND AGGREGIEREN UM DIE ANDEREN SPALTEN SINNVOLL ZUSAMMENZUFASSEN'
select
substr(rs,1.5) as krid,	
st_union(GEOMETRY) AS GEOMETRY,        -- st_union (oder gunion) verschmilzt die Geometrien der gruppierten Zeilen also DISSOLVE!
astext(st_union(GEOMETRY)) AS WKT,     -- noch einmal als WKT-text ausgeben, um den Geometrietyp zu prüfen 
count(rs) as anzahl,                   -- die anzahl der zusammengefassten rs-Zeilen wird gezählt (Anzahl der Gemeinden im LKR)
sum(ewz) as ewz_kreis,		       -- Die Einwohnerzahl der Gemeinden wird summiert
group_concat(gen,'; ') as gem_liste   -- Die Gemeindenamen aus der Spalte gen werden als Liste mit dem Trennzeichen Semikolon geschrieben                  
from gemeinden_ewz 		       -- es wird von gemeinden_ewz, der Tabelle mit den gejointen Einwohner gewählt!  
group by substr(rs,1,5) 	       -- Alle Zeilen mit dem gleichen krid werden zusammengefasst es gibt nur eine Zeile je landkreis

--DEN GEOMETRIETYP GENERELL AUF MULTIPOLYGON SETZEN

select
casttomultipolygon(st_union(GEOMETRY)) AS GEOMETRY, --- casttomultipolygon sorgt für durchgehend Multipolygon-Geometrien
astext(casttomultipolygon(st_union(GEOMETRY))) AS WKT,
count(rs) as anzahl,
group_concat(gen,'; ') as gem_liste,
sum(ewz) as ewz_kreis,
substr((rs,1,5) as krid
from gemeinden_ewz
group by substr(rs,1,5)

--LANDKREISNAMEN ANJOINEN

select
casttomultipolygon(st_union(geometry)) as GEOMETRY,
substr(g.rs,1,5) as krid,
l.nam as name,
count(g.gen) as anzahl,
sum(g.ewz) as ewz,
group_concat(g.gen,'; ') as liste
from gemeinden_ewz as g join lkr as l on (substr(g.rs,1,5) = l.krid)   -- die Landkreistabelle wird über das neue krid-feld angehängt
group by substr(rs,1,5)

--Hiermit haben wir eine vollständige DISSOLVE-FUNKTION mit Agreggierung von Spalten.

create table landkreise as
select
casttomultipolygon(st_union(geometry)) as GEOMETRY,
substr(g.rs,1,5) as krid,
l.nam as name,
count(g.gen) as anzahl,
sum(g.ewz) as ewz,
group_concat(g.gen,'; ') as liste
from gemeinden_ewz as g join lkr as l on (substr(g.rs,1,5) = l.krid)  -- die Landkreistabelle wird angehängt
group by substr(rs,1,5); -- Alle Zeilen mit dem gleichen krid werden zusammengefasst es gibt nur eine Zeile je landkreis


Select RecoverGeometryColumn("landkreise",'GEOMETRY',25833,'MULTIPOLYGON');  --legt die Geometriespalte an
Select CreateSpatialIndex("landkreise",'GEOMETRY');  --erzeugt einen räumlichen Index

--Wenn Lücken in der Ausgangsgeometrie sind und im ergebnis Risse zu sehen sind, dann vorher Geometriebereinigung
-- mit GRASS v.clean oder eine Buffer-Funktion isn Skript einbauen:
casttomultipolygon(buffer(GUnion(Buffer(g.geometry,0.01)),-0.01)) as geometry

-- Die ganze Abfrage lässt sich auch ogr2ogr übergeben
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192  -f SQLite -dsco SPATIALITE=yes -lco SRID=25833 -nln kreise -lco COMPRESS_GEOM=YES -skipfailures -gt unlimited -a_srs EPSG:25832 datei.sqlite \
-sql"create table landkreise as select
casttomultipolygon(st_union(g.GEOMETRY)) AS GEOMETRY, 
count(g.rs) as anzahl,
group_concat(g.gen,'; ') as gem_liste,
sum(g.ewz) as ewz_kreis,
l.nam as name,
substr(rs,1,5) as krid
from gemeinden_ewz as g inner join lkr as l on (l.krid = substr(g.rs,1,5)) -- die Landkreistabelle wird angehängt
group by substr(rs,1,5)"


select 'AUFGABE WIE IM MODELLER-KURS'
/* Waldanteil und Waldfläache je EW ermitteln 
in mehreren Abfragen hintereinander  */

-- Einwohnertabelle an Gemeinden anbinden, über einen Join an den Regionalschlüssel
create table gemewz as
Select
g.geometry AS geometry,
g.RS AS RS,
g.GEN AS GEN,
e.EWZ AS EWZ
from
gemeinden as g  inner join EWZ as e ON (e.RS = g.RS) -- Einwohner an gemeinden anjoinen
;

--Wald und Gemeindeflächen Verschneiden, um Waldflchen den gemeinden zuordnen zu können
create table intersectum as
Select
    g.RS AS RS,
    g.GEN AS GEN,
    ST_Intersection(g.geometry,d.geometry) AS geometry -- Intersect Geometrie-verschneidung, um die gemeinsamen Wald-Gemeinde-Geometrien zu ermitteln.
    from
    gemeinden as g  left join dlm250 as d  ON intersects(g.geometry,d.geometry) -- Raeumliche Abfrage: nur Gemeinden verschneiden, die sich berühren
    where  d.nutzung = 'AX_Wald'   -- Nur objekte aus dem DLM nutzen, die tatschlich Wald sind
         and d.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='dlm250' AND search_frame=g.geometry)  -- Räumlichen Index benutzen (optional)
;

-- Wald-Gemeinde-Geometrien nach regionalschlüssel verschmelzen, um die Gesamtwaldfläche jeder Gemeinde zu ermitteln
-- Danach gibt es jeweils eine Multipart-Geometrie des Waldes je Gemeinde
create table wdissolve as
select
RS,
(Gunion(geometry)) as geometry -- Gunion ist dissolve in kombination mit group by, hier nach RS gruppieren und die Geometrie verschmelzen
from
intersectum
group by RS;

-- Ermittelte Wald-Gemeinde-Flächen anjoinen und für die Berechnung des Waldanteils nutzen

create table waaanteil as
Select
g.geometry AS geometry, --die Gemeindegeometrie
g.RS AS RS, 		--Regionalschlüssel
g.GEN AS GEN, 		-- Gemeindename
g.EWZ AS EWZ,		-- Einwohnerzahl
round((area(i.geometry) / 1000000),2) AS WFL, -- Die Waldfläche wird berechnet aus der wdissolve-Geometrie
round((area(i.geometry)  / (area(g.geometry))* 100)) AS anteil, -- Der Waldanteil wird aus der Wald- und Gesamtgeometrie berechnet
round(area(i.geometry)  / g.EWZ)  AS WF_EW		-- Waldfläche je Einwohner wird berechnet.
from wdissolve as i left join gemewz as g on (i.RS = g.RS);

Select RecoverGeometryColumn("waaanteil",'geometry',25833,'MULTIPOLYGON');
Select CreateSpatialIndex("waaanteil",'geometry');

SELECT UpdateLayerStatistics('waaanteil');
-- Hilfstabellen löschen
drop table gemewz;
drop table intersectum;
drop table wdissolve;

'ALTERNATIVE MIT VERSCHACHTELTET ABFRAGE'
/* Waldanteil und Waldfläache je EW ermitteln 
verschachtelt  */
-- Hier sind alle Abfragen in verschachtelten Funktionen zusammengefasst
---Verschachtelete Funktionen mit räumlichen Index
create table waaanteil as
Select
g.geometry AS geometry,
g.RS AS RS,
g.GEN AS GEN,
e.EWZ AS EWZ,
round((area(Gunion(ST_Intersection(g.geometry,d.geometry))) / 1000000),2) AS WFL,
round((area(Gunion(ST_Intersection(g.geometry,d.geometry)))) / (area(g.geometry))* 100) AS anteil,
round((area(Gunion(ST_Intersection(g.geometry,d.geometry)))) / e.EWZ)  AS WF_EW
from
(gemeinden as g left join dlm250 as d ON intersects(g.geometry,d.geometry)) left join EWZ as e ON e.RS = g.RS
where d.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='dlm250' AND search_frame=g.geometry)
   and
    d.nutzung = 'AX_Wald'
Group by g.RS;

Select RecoverGeometryColumn('waaanteil','geometry',25833,'MULTIPOLYGON');
Select CreateSpatialIndex('waaanteil','geometry');
select updatelayerstatistics("waaanteil");

-- ohne räumlichen Index
create table waaanteil as
Select
g.geometry AS geometry,
g.RS AS RS,
g.GEN AS GEN,
e.EWZ AS EWZ,
round((area(Gunion(ST_Intersection(g.geometry,d.geometry))) / 1000000),2) AS WFL,
round((area(Gunion(ST_Intersection(g.geometry,d.geometry)))) / (area(g.geometry))* 100) AS anteil,
round((area(Gunion(ST_Intersection(g.geometry,d.geometry)))) / e.EWZ)  AS WF_EW
from
(gemeinden as g left join dlm250 as d ON intersects(g.geometry,d.geometry)) left join EWZ as e ON e.RS = g.RS
where
    d.nutzung = 'AX_Wald'
Group by g.RS;

---------------
----------------
------------
--
'VERSCHNEIDUNGEN'
-- INTERSECT ZWEIER GEOMETRIEN
create table verschneidung as   --Erzeugend der neuen Tabelle über create table
select                          -- Die Tabelle wird aus der Abfrage erstellt
  casttomultipolygon(st_intersection(a.geometry,b.geometry)) AS geometry, --Die Funktion ST_intersect entspricht der Intersect / Verschneiden-Funktion in GIS-Pprogrammen
  a.rs,								   -- casttomultipolygon ermöglicht eine Multipolygon-Geometrie im Ergebnis
  a.gen,
  a.bez,                                                             -- weitere Spalten können mit abgefragt werden (Aufzählung mit Komma)       
  b.nutzung as nutzung 
  
from gemeinden as a inner join dlm250 as b on st_intersects(a.geometry,b.geometry) = 1 -- Die Verschneidung wird nur für Geometrien durchgeführt, die sich wirklich schneiden
   where nutzung = 'AX_Wald' and  a.ROWID IN
              (SELECT ROWID FROM SpatialIndex WHERE f_table_name='gemeinden' AND search_frame=b.geometry); -- Ein räumlicher Index wird verwendet, dieser Teil ist optional. Bei großen Datenmengen, aber für schnelles Verschneiden unerlässslich
---------------
Select RecoverGeometryColumn('verschneidung','Geometry',25832,'MULTIPOLYGON');
Select CreateSpatialIndex('verschneidung','Geometry');
SELECT UpdateLayerStatistics('verschneidung');


--DIFFERENZ / ERASS ZWEIER GEOMETRIEN IST KOMPLIZIERTER, WEIL ZUM AUSSTANZEN NUR EINZELGEOMETRIEN VERWENDET WERDEN KÖNNEN

-- Schritt 1: aus beiden Layern eine vollstndig verschmolzene Geometrie erzeugen
-----------------
create table diff_vorne			-- Die Tabelle aus der gestanzt wird
as
select
Buffer(Gunion(buffer(a.geometry,0.01)),0.01) AS geometry		-- verschmelzen der ersten Geometrie mit Pufferung zum Lücken schließen
      from gemeinden as a;      -- DIES IST DER URSPRUNGSLAYER A, DER IM LETZTEN SCHRITT DES SKRIPTES NOCH EINMAL EINGETRAGEN WERDEN MUSS

Select RecoverGeometryColumn('diff_vorne','Geometry',25832,'MULTIPOLYGON');
Select CreateSpatialIndex('diff_vorne','Geometry');
SELECT UpdateLayerStatistics('diff_vorne');

----------------
create table diff_stanz 		-- Die Tabelle die stanzt
as
select
Buffer(Gunion(buffer(a.geometry,0.01)),0.01) AS geometry		-- verschmelzen der ersten Geometrie mit Pufferung zum Lücken schließen
      from dlm250 as a
where a.nutzung = 'AX_Wald';  -- DIES IST DER URSPRUNGSLAYER B, DER DIE LÖCHER IN DEN LAYER A STANZT

Select RecoverGeometryColumn('diff_stanz','Geometry',25832,'MULTIPOLYGON');
Select CreateSpatialIndex('diff_stanz','Geometry');
SELECT UpdateLayerStatistics('diff_stanz');

--Schritt 2: Mit einem Layer ein Loch in den anderen Layer stanzen
-----------------
create table diffdiss as		--diffdiss ist der Ergebnis des Verschneidungsprozesses mmit st_difference		
select
      casttomultipolygon(st_difference(diff_vorne.geometry,diff_stanz.geometry)) AS geometry 			--Der Layer diffstanz schneidet Löcher in die Geometrie von diffvorne
      from diff_vorne inner join diff_stanz on st_intersects(diff_vorne.geometry,diff_stanz.geometry) = 1
       where  diff_stanz.ROWID IN
              (SELECT ROWID FROM SpatialIndex WHERE f_table_name='diff_stanz' AND search_frame=diff_vorne.geometry);

Select RecoverGeometryColumn('diffdiss','Geometry',25832,'MULTIPOLYGON');
Select CreateSpatialIndex('diffdiss','Geometry');
SELECT UpdateLayerStatistics('diffdiss');

---Alternative SCHRITT 1 UND SCHRITT 2 DURCH VERSCHACHTELUNG ZUSAMMENFASSEN



create table diffdiss2 as		--diffdiss ist der Ergebnis des Verschneidungsprozesses mmit st_difference		
select
         casttomultipolygon(st_difference(Buffer(Gunion(buffer(a.geometry,0.01)),0.01),Buffer(Gunion(buffer(a.geometry,0.01)),0.01))) AS geometry --Der Layer diffstanz schneidet Löcher in die Geometrie von diffvorne
      --casttomultipolygon(st_difference(Gunion(buffer(a.geometry,0.01)),Gunion(buffer(b.geometry,0.01)))) AS geometry 			--Der Layer diffstanz schneidet Löcher in die Geometrie von diffvorne
      from gemeinden as a inner join dlm250 as b on st_intersects(a.geometry,b.geometry) = 1
       where b.nutzung = 'AX_Wald' and  b.ROWID IN
              (SELECT ROWID FROM SpatialIndex WHERE f_table_name='dlm250' AND search_frame=a.geometry);

Select RecoverGeometryColumn('diffdiss2','Geometry',25832,'MULTIPOLYGON');
Select CreateSpatialIndex('diffdiss2','Geometry');
SELECT UpdateLayerStatistics('diffdiss2');


-------------
--ATTRIBUTE ÜBER EIN INTERSET AUF DEN DIFFERENZLAYER ÜBERTRAGEN
---------------
create table differenzfertig as
select
  casttomultipolygon(st_intersection(a.geometry,diffdiss.geometry)) AS geometry,   -- Über ein Intersect werden Einzelgeometrien und  Attribute wieder hergestellt
  a.* 
  from gemeinden as a inner join diffdiss on st_intersects(a.geometry,diffdiss.geometry) = 1  -- HIER MUSS FÜR DIFF_EINGABE DER URSPRUNGSLAYER A EINGETRAGEN WERDEN
   where  a.ROWID IN
              (SELECT ROWID FROM SpatialIndex WHERE f_table_name='gemeinden' AND search_frame=diffdiss.geometry);

Select RecoverGeometryColumn('differenzfertig','Geometry',25832,'MULTIPOLYGON');
Select CreateSpatialIndex('differenzfertig','Geometry');
SELECT UpdateLayerStatistics('differenzfertig');

-------
--------
---EINE VEREINIGUNG ERREICHT MAN NICHT ÜBER GUNION - DIES FÜHRT ZU DOPPELTEN GEOMETRIEN
-- SONDERN IN DEM ÜBER EINE NORMALE ZEILEN-UNION DIE ERGEBNISSE DES INTERSECT UND DES DIFFERENZ-LAYERS VEREINIGT WERDEN
create table vereinigung as
select
geometry,
rs,
gen,
bez,
nutzung
from verschneidung
union
select
geometry,
rs,
gen,
bez,
'andere' as nutzung
from differenzfertig;

Select RecoverGeometryColumn('vereinigung','Geometry',25832,'MULTIPOLYGON');
Select CreateSpatialIndex('vereinigung','Geometry');
SELECT UpdateLayerStatistics('vereinigung');



/* 
-----------------------------------------
GKG-Kassel - Dr.-Ing. Claas Leiner
QGIS-Support und mehr

Geodatenservice, Kartenwerkstatt &
GIS-Schule Kassel

Wilhelmshöher Allee 304 E
34131 Kassel
Tel. 0561/56013445
claas.leiner@gkg-kassel.de
http://www.gkg-kassel.de
----------------------------------------
Unterstützen Sie QGIS
QGIS-DE e.V. | http://qgis.de
*/