#!/bin/bash
#-spat 8.08171944425 49.2785500311 8.90172549094 49.7243634451
#-spat 551537 5984753 578712 6001370 -spat_srs EPSG:25832 -progress

#wget https://download.geofabrik.de/europe/germany/bayern-latest.osm.pbf
#wget https://download.geofabrik.de/europe-latest.osm.pbf





echo
echo
echo OSM-PBF nach Postgis
echo
echo
rechner="localhost"
echo
echo
#read -p "Name oder IP des Rechners angeben (wenn lokal nichts):   " rechner
echo
echo
#read -p "Namen der Datenbank eingeben und return drücken:   " db
db="puvaris"
echo
echo
#read -p "Benutzername  eingeben und return drücken:   " user
user="claas"
echo
echo
# read -p "Passwort eingeben und return drücken:   " pw
pw=cff23xj7
echo
port="5432"
echo
#read -p "Wenn Port nicht 5432, die Portnummer eingeben und return drücken:   " port
echo
schema="rpsolar"
echo
#read -p "DB-Schema-Name eingeben, wenn benutzerdefiniertes Schema vorliegt und return drücken:   " schema
echo
echo
#read -p "Verzeichnis mit den OSM-Dateien eingeben   " pfad
echo
echo
echo Koordinaten des Ausschnitts angeben, wenn alles importiert werden soll n eingeben
echo
echo
#read -p "Koordinaten des Gebiets eingeben in der Form xmin ymin xmax ymax oder n:   " raum 
echo
echo
#if [ "$raum" = "n" ]; then
raum="3.7 47 17.1 55.5"
#fi

#raum="10.704808347376298 47.936540914156964 11.26204006242117 48.23051636382486"
echo
echo
echo Rechner ist $rechner
echo
echo
echo Datenbank ist $db
echo
echo
echo Nutzer ist $user
echo
echo
echo passwort ist $pw
echo
echo
echo port ist $port
echo
echo
echo schema ist $schema
echo
echo
#echo pfad ist $pfad
echo
echo
#echo Ausschnitt ist $raum
echo
echo
read -n1 -r -p "Beliebige Taste" key
echo
echo

#cp osmconf.ini "$pfad"
#cp spalten_anlegen.sql "$pfad"

#cd "$pfad"



for pbfs in *.pbf ; do
	#pointd
	
	#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln osm_poi -update -append -gt unlimited -spat $raum  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name,place,highway,railway_turnout_side,public_transport,addr_housenumber,leisure,amenity,office,tourism,shop,craft,healthcare,social_facility,building,wheelchair,shelter  from points where leisure is not null or amenity is not null or office is not null or tourism is not null or shop is not null or craft is not null or healthcare is not null or social_facility is not null or building is not null or addr_housenumber is not null or highway is not null or railway_turnout_side is not null or public_transport is not null or place is not NULL"

	#Verkehr und Gewässer
	ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln osm_linien -update -append -gt unlimited -spat $raum -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name,highway,tracktype,railway,bridge,tunnel,ref,oneway,sidewalk,waterway,power from lines where highway is not null or railway is not null or waterway is not null or power is not null"  
	

	#pols
	#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln osm_landuse -update -append -gt unlimited -spat $raum  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name,landuse,natural,waterway,leisure,amenity,man_made,place,aeroway,building,addr_housenumber,postal_code,admin_level from multipolygons where building is not NULL OR landuse is not null OR natural is not null OR waterway is not null OR leisure is not null OR amenity is not null OR man_made is not null OR place is not null OR aeroway is not null or admin_level is not null or addr_housenumber is not null or postal_code is not null"

        #pols
#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln str_Umspannwerk -overwrite  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name, power, operator,voltage,substation,ref  from points where  power in ('station','sub_station' , 'substation')"
	
#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln str_UmspannwerkP -overwrite  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name, power,operator,voltage,substation,ref  from multipolygons where power in ('station','sub_station' , 'substation')"

#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln str_UmspannwerkP -overwrite  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name, power,operator,voltage,substation,ref  from multipolygons where power in ('station','sub_station' , 'substation')"

        
#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln str_UmspannwerkLV -overwrite  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name, power,operator,voltage,substation,ref  from multipolygons where power in ('station','sub_station' , 'substation')"        

#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'" -lco GEOMETRY_NAME=geom  -lco FID=fid  -nln kraftwerke_pol -overwrite  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select name,power,plant,plant_method,plant_output,generator_source,generator_method,generator_output_electricity from multipolygons where power = 'generator' or  power = 'plant'  or generator is not null"



#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832  -nln kraftwerke2  -gt unlimited -update -addfields    -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,power,plant,plant_method,plant_output,generator_source,generator_method,generator_output_electricity,cast(height_hub as integer(3)) as nabenhoehe,cast(height as integer(3)) as hoehe from points where power = 'generator' or  power = 'plant'  or generator is not null"



#Leitungen
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -update -append  -nln leitungen -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,type,man_made,power,voltage,cables,substance from lines where power in ('line','minor_line') or man_made = 'pipeline'"
	
	#multilines
	#ogr2ogr --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -progress -f PostgreSQL PG:"dbname='$db' host='$host' schemas=$schema port='$port' user='$user' password='$pw'"  -nln multilinestrings -update -append -gt unlimited -spat $raum  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  "$pbfs" -sql "select * from multilinestrings "


done
#psql -d $db -f "spalten_anlegen.sql"
psql -d $db -f "strassen_import.sql"
