alter table rpsolar.osm_linien
add column autobahn integer default 0;
alter table rpsolar.osm_linien
add column bundesstrasse integer default 0;
alter table rpsolar.osm_linien
add column landesstrasse integer default 0;
alter table rpsolar.osm_linien
add column kreisstrasse integer default 0;
alter table rpsolar.osm_linien
add column fahrweg integer default 0;
alter table rpsolar.osm_linien
add column wohnstrasse integer default 0;
alter table rpsolar.osm_linien
add column fussgaengerzone integer default 0;
alter table rpsolar.osm_linien
add column fussweg integer default 0;
alter table rpsolar.osm_linien
add column sonstige_hauptstr integer default 0;
alter table rpsolar.osm_linien
add column strasse integer default 0;
alter table rpsolar.osm_linien
add column ha_strasse integer default 0;
alter table rpsolar.osm_linien
add column treppe integer default 0;


update  rpsolar.osm_linien
set
autobahn = 1
where   "highway" in ( 'motorway' , 'motorway_link' );


update  rpsolar.osm_linien
set
bundesstrasse = 1
where    "highway"  in( 'primary' , 'primary_link', 'trunk', 'trunk_link' );


update  rpsolar.osm_linien
set
landesstrasse = 1
where    "highway" in( 'secondary' , 'secondary_link' );


update  rpsolar.osm_linien
set
kreisstrasse = 1
where    "highway" = 'tertiary' ;


update  rpsolar.osm_linien
set
wohnstrasse = 1
where     "highway" in (  'residential' , 'road' , 'unclassified', 'service');


update  rpsolar.osm_linien
set
fussgaengerzone = 1
where   "highway"  in ( 'pedestrian','living_street') ;


update  rpsolar.osm_linien
set
fussweg = 1
where    "highway" in(  'track' , 'track; path', 'path' , 'footway' ,'cycleway') and (tracktype not in ('grade1')) or tracktype is NULL;

update  rpsolar.osm_linien
set
fahrweg = 1
where    "highway" =  'track' and tracktype in ('grade1');

update  rpsolar.osm_linien
set
treppe = 1
where    "highway"= 'steps';


update  rpsolar.osm_linien
set
sonstige_hauptstr = 1
where    "highway" in ( 'secondary' , 'secondary_link', 'tertiary' );


update  rpsolar.osm_linien
set
strasse = 1
where    "highway" in ( 'living_street' ,  'pedestrian' , 'residential' , 'road' , 'service',  'unclassified' );


update  rpsolar.osm_linien
set
ha_strasse = 1
where    "highway" in ('primary' , 'primary_link', 'trunk', 'trunk_link', 'secondary' , 'secondary_link', 'tertiary' );

--Spalten fuer die Symbolisierung des Schienenetzes anlegen
alter table rpsolar.osm_linien
add column eisb_gr integer default 0;
alter table rpsolar.osm_linien
add column eisb_gr_tu integer default 0;
alter table rpsolar.osm_linien
add column eisb_kl integer default 0;
alter table rpsolar.osm_linien
add column eisb_kl_tu integer default 0;
alter table rpsolar.osm_linien
add column strab integer default 0;
alter table rpsolar.osm_linien
add column ubahn integer default 0;

-- Spalten zur Symbolsierung des Schienennetzes füllen
-- Eisenbahnen großer Maßstab ohne Tunnel
update  rpsolar.osm_linien
set
eisb_gr = 1
where  "railway" =  'rail' and  ( "tunnel" is NULL or  "tunnel" in ( 'no' ));

update  rpsolar.osm_linien
set
eisb_gr_tu = 1
where  "railway" = 'rail'  and  "tunnel" in ( 'building_passage' , 'culvert' , 'yes' );

update  rpsolar.osm_linien
set
eisb_kl = 1
where  "railway" =  'rail' and  "name" is not null and ( "tunnel" is NULL or  "tunnel" in ( 'no' ));

update  rpsolar.osm_linien
set
eisb_kl_tu = 1
where  "railway" =  'rail' and  "name" is not null and  "tunnel"  in ( 'building_passage' , 'culvert' , 'yes' );

update  rpsolar.osm_linien
set
strab = 1
where   ("railway" = 'tram' or  "railway" = 'light_rail') and ("tunnel" is NULL or "tunnel" = 'no');

update  rpsolar.osm_linien
set
ubahn = 1
where  "railway" =  'subway' or ("railway" = 'light_rail' and "tunnel"  in ( 'building_passage' , 'culvert' , 'yes')) ;
